Limit usage of vertex arrays to correct states.
[wine/multimedia.git] / tools / wineinstall
blobf6c915176c681843934456ae5937264b8efb69d7
1 #!/bin/bash
2 # WINE Installation script
3 # Can do almost everything from compiling to configuring...
5 # Copyright 1999 Ove Kåven
7 # This library is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU Lesser General Public
9 # License as published by the Free Software Foundation; either
10 # version 2.1 of the License, or (at your option) any later version.
12 # This library is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
15 # Lesser General Public License for more details.
17 # You should have received a copy of the GNU Lesser General Public
18 # License along with this library; if not, write to the Free Software
19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
22 #--- defaults (change these if you are a packager)
23 CONFARGS="" # configure args, e.g. --prefix=/usr --sysconfdir=/etc
24 prefix=/usr/local # installation prefix
25 sysconfdir=$prefix/etc # where wine.conf and the global registry are supposed to be
26 bindir=$prefix/bin # where winelib apps will be (or are) installed
27 libdir=$prefix/lib # where libwine.so will be (or is) installed
28 exdir=documentation/samples # where the sample system.ini resides
29 GCONF=$sysconfdir/wine.conf # default path of the wine.conf global config file
30 LCONF=~/.wine/config # default path of the local config file
31 BINDIST=no # whether called from a binary package config script
32 DOGLOBALCONF=auto # whether to autogenerate wine.conf
33 DOLOCALCONF=auto # whether to autogenerate localconf
34 DOWCHK=auto # whether to autoconfigure existing-windows installation
35 DOWINE=auto # whether to autoconfigure no-windows installation
36 DOREG=auto # whether to install default registry
37 DOAPP=auto # whether to install applications, distributed with Wine
38 SYSREG=yes # whether to make root's registry global (system-default)
40 # "make install" still installs the dlls into $libdir, but this may change in the future
41 # (DLLPATH should point to them if/when they are not in standard ld.so paths)
42 DLLPATH=$libdir/wine # default path of the dll .so files (except libwine.so)
44 # this is only for existing-windows installs
45 WINECONF=tools/wineconf # path to the wineconf perl script
47 # this is only for no-windows installs
48 WINEINI=$exdir/config # path to the default wine config file (also used by wineconf)
49 WININI=/dev/null # path to the default win.ini
50 SYSTEMINI=$exdir/system.ini # path to the default system.ini
51 REGEDIT=programs/regedit/regedit # path to the regedit winelib application
52 DEFREG=winedefault.reg # path of the registry file to be fed to regedit
53 # CROOT=/var/wine # path of the fake Drive C (asks user if not set)
54 DEFCAT=cat # program to cat $DEFREG with (some packages need zcat)
55 #--- end of defaults
57 # temporary files used by the installer
58 TMPCONF=/tmp/wineinstall.conf
60 # functions
62 function std_sleep {
63 sleep 1
66 function conf_question {
67 # parameters: $1 = importance, $2 = question-id, $3+ = message lines
68 # the first two parameters can be used by e.g. debconf in debian packages
69 # but here we just print the message
70 shift 2
71 echo
72 local LINE="$1"
73 while shift
74 do {
75 echo "$LINE"
76 LINE="$1"
78 done
81 function conf_reset_question {
82 # parameters: $1 = question-id
83 # this is used to flush any cached answers and "already-displayed" flags
84 shift # dummy command
87 function conf_yesno_answer {
88 unset ANSWER
89 while [ "$ANSWER" != 'yes' ] && [ "$ANSWER" != 'no' ]
90 do {
91 echo -n "$1"
92 read ANSWER
94 done
97 function conf_string_answer {
98 echo -n "$1"
99 read ANSWER
102 function create_windows_directories {
103 for tdir in "$CROOT/windows" "$CROOT/windows/system" \
104 "$CROOT/windows/command" \
105 "$CROOT/windows/Start Menu" "$CROOT/windows/Start Menu/Programs" \
106 "$CROOT/Program Files" "$CROOT/Program Files/Common Files" \
107 "$CROOT/windows/Profiles" "$CROOT/windows/Profiles/Administrator" \
108 "$CROOT/windows/Fonts" "$CROOT/windows/Start Menu/Programs/Startup"
109 do [ -d "$tdir" ] || mkdir "$tdir"
110 done
111 [ -f "$CROOT/windows/win.ini" ] || cp "$WININI" "$CROOT/windows/win.ini"
112 [ -f "$CROOT/windows/system.ini" ] || cp "$SYSTEMINI" "$CROOT/windows/system.ini"
115 #creates symbolic link in windows directory to installed winelib application
116 #parameters:
117 # - name of the installed winelib application
118 # - full path to application in the winelib directory
119 function link_app {
120 if [ "$WINEINSTALLED" = 'no' ]
121 then {
122 ln -sf $PWD/programs/$1/$1.exe.so $2
124 else {
125 ln -sf $libdir/wine/$1.exe.so $2
130 #puts windows applications replacements to windows directories,
131 #configures them
132 function configure_wine_applications {
133 link_app start "$CROOT/windows/command/start.exe"
134 link_app notepad "$CROOT/windows/notepad.exe"
135 link_app regedit "$CROOT/windows/regedit.exe"
136 link_app rundll32 "$CROOT/windows/rundll32.exe"
137 link_app wcmd "$CROOT/windows/system/wcmd.exe"
138 link_app control "$CROOT/windows/system/control.exe"
139 link_app winhelp "$CROOT/windows/system/help.exe"
140 link_app notepad "$CROOT/windows/system/notepad.exe"
141 link_app progman "$CROOT/windows/system/progman.exe"
142 link_app regsvr32 "$CROOT/windows/system/regsvr32.exe"
143 link_app winemine "$CROOT/windows/system/winmine.exe"
144 link_app winver "$CROOT/windows/system/winver.exe"
145 link_app uninstaller "$CROOT/windows/uninstall.exe"
146 link_app winhelp "$CROOT/windows/winhelp.exe"
147 link_app winhelp "$CROOT/windows/winhlp32.exe"
150 # startup...
152 echo "WINE Installer v0.74"
153 echo
155 if [ "$BINDIST" = 'no' ]
156 then {
158 if ! [ -f configure ]
159 then {
160 if [ -f ../configure ]
161 then {
162 pushd ..
164 else {
165 echo "You're running this from the wrong directory."
166 echo "Change to the Wine source's main directory and try again."
167 exit 1
173 if [ `whoami` == 'root' ]
174 then {
175 echo "You are running wineinstall as root, this is not advisable. Please rerun as a user."
176 echo "Aborting."
177 exit 1
181 if [ ! -w . ]
182 then {
183 echo "The source directory is not writable. You probably extracted the sources as root."
184 echo "You should remove the source tree and extract it again as a normal user."
185 exit 1
189 # check whether RPM installed, and if it is, remove any old wine rpm.
190 hash rpm &>/dev/null
191 RET=$?
192 if [ $RET -eq 0 ]; then
193 if [ -n "`rpm -qi wine 2>/dev/null|grep "^Name"`" ]; then
194 echo "Warning: Old Wine RPM install detected. Do you want to remove it first?"
195 conf_yesno_answer "(yes/no) "
196 if [ "$ANSWER" = 'yes' ]; then
197 echo "We need to remove the rpm as root, please enter your root password"
198 echo
199 echo Starting wine rpm removal...
200 su -c "rpm -e wine; RET=$?"
201 if [ $RET -eq 0 ]; then
202 echo Done.
203 else
204 echo "FAILED. Probably you aren't installing as root."
205 echo "Expect problems (library conflicts with existing install etc.)."
207 else
208 echo "Sorry, I won't install Wine when an rpm version is still installed."
209 echo "(Wine support suffered from way too many conflicts between RPM"
210 echo "and source installs)"
211 echo "Have a nice day !"
212 exit 1
217 # check whether wine binary still available
218 if [ -n "`which wine 2>/dev/null|grep '/wine'`" ]; then
219 echo "Warning !! wine binary (still) found, which may indicate"
220 echo "a (conflicting) previous installation."
221 echo "You might want to abort and uninstall Wine first."
222 std_sleep
225 # run the configure script, if necessary
227 if [ -f config.cache ] && [ -f Makefile ] && [ Makefile -nt configure ]
228 then {
229 echo
230 echo "I see that WINE has already been configured, so I'll skip that."
231 std_sleep
232 # load configure results
233 . ./config.cache
235 else {
236 echo "Running configure..."
237 echo
238 if ! ./configure -C $CONFARGS --prefix=$prefix
239 then {
240 echo
241 echo "Configure failed, aborting install."
242 rm -f config.cache
243 exit 1
246 # load configure results
247 . ./config.cache
248 # make sure X was found
249 eval "$ac_cv_have_x"
250 if [ "$have_x" != "yes" ]
251 then {
252 echo "Install the X development headers and try again."
253 rm -f config.cache
254 exit 1
260 # now do the compilation and install, we need to always do this because we
261 # don't want the 'make install' command we might run to run 'make' as root
262 if [ `whoami` != 'root' ]
263 then {
264 # ask the user if they want to build and install wine
265 echo
266 echo "We need to install wine as root user, do you want us to build wine,"
267 echo "'su root' and install Wine? Enter 'no' to continue without installing"
268 conf_yesno_answer "(yes/no) "
269 ROOTINSTALL="$ANSWER"
271 if [ "$ROOTINSTALL" = "yes" ]
272 then {
273 # start out with the basic command
274 sucommand="make install"
276 # if the user doesn't have $libdir in their ld.so.conf add this
277 # to our sucommand string
278 if [ -f /etc/ld.so.conf ]
279 then
280 if ! grep -s "$libdir" /etc/ld.so.conf >/dev/null 2>&1
281 then {
282 echo
283 echo "$libdir doesn't exist in your /etc/ld.so.conf, it will be added"
284 echo "when we perform the install..."
285 sucommand="$sucommand;echo $libdir>>/etc/ld.so.conf"
288 # run ldconfig always just in case some updated files dont get linked
289 sucommand="$sucommand;$ac_cv_path_LDCONFIG"
292 fi # [ "$ROOTINSTALL" = "yes" ]
294 echo
296 echo "Compiling WINE. Grab a lunch or two, rent a video, or whatever,"
297 echo "in the meantime..."
298 echo
299 std_sleep
301 # try to just make wine, if this fails 'make depend' and try to remake
302 if ! { make; }
303 then {
304 if ! { make depend && make; }
305 then {
306 echo
307 echo "Compilation failed, aborting install."
308 exit 1
314 if [ "$ROOTINSTALL" = "yes" ]
315 then {
316 echo
318 echo "Performing 'make install' as root to install binaries, enter root password"
320 std_sleep
322 if ! su root -c "$sucommand"
323 then {
324 if ! su root -c "$sucommand"
325 then {
326 echo
327 echo "Either you entered an incorrect password or we failed to"
328 echo "run '$sucommand' correctly."
329 echo "If you didn't enter an incorrect password then please"
330 echo "report this error and any steps to possibly reproduce it to"
331 echo "http://bugs.winehq.org/"
332 echo
333 echo "Installation failed, aborting."
334 exit 1
340 echo
342 # see if wine is installed on the users system, if not prompt them
343 # and then exit
344 if [ ! `which wine` ]
345 then
346 echo "Could not find wine on your system. Run wineinstall as root to install wine"
347 echo "before re-running wineinstall as a user."
348 echo
349 echo "Exiting wineinstall"
350 exit 1;
353 WINEINSTALLED=yes
355 else {
356 # user didn't want to install wine so tell them about running from the
357 # current directory and set some stuff up for them
359 # setup to run from current directory
360 DLLPATH="$PWD/dlls"
361 if [ -z "$LD_LIBRARY_PATH" ]
362 then LD_LIBRARY_PATH="$PWD:$DLLPATH"
363 else LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$PWD:$DLLPATH"
365 export LD_LIBRARY_PATH
366 echo
367 echo "NOTE! To run Wine without installing, you must set the environment variable"
368 echo "LD_LIBRARY_PATH to $PWD:$DLLPATH"
369 echo "in your logon scripts."
370 echo
372 WINEINSTALLED=no
374 fi # [ "$ROOTINSTALL" = "yes" ]
376 fi # [ `whoami` != 'root' ]
379 fi # BINDIST
381 # now check whether we should generate wine.conf
382 if [ -z "$DOGLOBALCONF" ]
383 then
384 DOGLOBALCONF=auto
387 if [ "$DOGLOBALCONF" = 'auto' ]
388 then {
389 # see if we already have a system wine.conf
390 if [ ! -f $GCONF ] && [ `whoami` = 'root' ]
391 then
392 DOGLOBALCONF=no
393 echo "Creation of a global config file is not supported in wineinstall at this"
394 echo "time. When the configuration architecture is cleaned up this functionality"
395 echo "will be restored to wineinstall."
396 echo
401 if [ "$DOLOCALCONF" = 'auto' ]
402 then {
403 # see if the user is root, if so, explicitly ask them if they want a
404 # local config file
405 if [ `whoami` = 'root' ]
406 then
407 echo "You are running as root. Do you want a local config file,"
408 echo "file, ~/.wine/config, created?"
409 conf_yesno_answer "(yes/no) "
410 DOLOCALCONF="$ANSWER"
411 else
412 # if the user has an existing config file ask them if they want us to
413 # overwrite it, otherwise just ask them if they want to create one
414 if [ -f "$LCONF" ]
415 then
416 echo "Found existing $LCONF, do you want to overwrite this"
417 echo "existing Wine configuration file?"
418 conf_yesno_answer "(yes/no) "
419 DOLOCALCONF="$ANSWER"
420 echo
421 if [ "$ANSWER" = "yes" ]
422 then
424 echo "Would you like to make a backup of this old config file?"
425 conf_yesno_answer "(yes/no) "
426 echo
427 if [ "$ANSWER" = "yes" ]
428 then
430 echo "Renaming $LCONF to $LCONF.old"
431 mv -f "$LCONF" "$LCONF.old"
432 echo
437 else
439 echo "Create local config file ~/.wine/config?"
440 conf_yesno_answer "(yes/no) "
441 DOLOCALCONF="$ANSWER"
442 echo
443 if [ "$ANSWER" = 'no' ]
444 then
445 conf_question high need_root \
446 "Aborting install. Try again as root to generate a system wine.conf."
447 exit 1
455 # generate $TMPCONF from existing windows install, if any
456 if [ "$DOLOCALCONF" = 'yes' ]
457 then {
458 if [ "$DOWCHK" = 'yes' ] || [ "$DOWCHK" = 'auto' ]
459 then {
460 echo -n "Searching for an existing Windows installation..."
461 if ! $WINECONF -inifile "$WINEINI" > $TMPCONF 2>/dev/null
462 then {
463 rm -f $TMPCONF > /dev/null
465 echo " not found. (no matching /etc/fstab mount entry found)"
466 conf_question low do_without_windows \
467 "Windows was not found on your system, so I assume you want" \
468 "a Wine-only installation. Am I correct?"
469 conf_yesno_answer "(yes/no) "
470 if [ "$ANSWER" = 'no' ]
471 then {
472 conf_question high windows_not_found \
473 "Aborting install. Make sure your Windows partition is mounted and try again," \
474 "or create $LCONF manually by copying from $WINEINI and adapting the drive paths."
475 exit 1
478 DOWINE=yes
480 else {
481 echo " found."
483 conf_question low do_without_windows \
484 "Windows was found on your system, and so we can use the Windows" \
485 "Drive as our Wine drive. You may, however, wish to create a clean" \
486 "Wine install anyways."
487 conf_yesno_answer "Should I use the Windows drive for the Wine install? (yes/no) "
488 if [ "$ANSWER" = 'yes' ]
489 then {
490 conf_reset_question windows_found
491 conf_question low windows_found \
492 "Created $LCONF using your existing Windows installation." \
493 "You probably want to review the file, though."
494 DOWINE=no
496 else {
497 DOWINE=yes
503 elif [ "$DOWINE" = 'auto' ]
504 then DOWINE=yes
507 elif [ "$DOWINE" = 'auto' ]
508 then
509 DOWINE=no
512 # setup a no-windows installation, if necessary
513 if [ "$DOWINE" = 'yes' ]
514 then {
515 # set an appropriate DCROOT
516 if [ `whoami` != 'root' ]
517 then DCROOT=~/c
518 else DCROOT=/c
521 conf_question low drivec_path \
522 "Configuring Wine without Windows." \
523 "Some fake Windows directories must be created, to hold any .ini files, DLLs," \
524 "start menu entries, and other things your applications may need to install." \
525 "Where would you like your fake C drive to be placed?"
526 while [ -z "$CROOT" ]
527 do {
528 conf_string_answer "(default is $DCROOT) "
529 [ -z "$ANSWER" ] && ANSWER="$DCROOT"
530 if ! [ -d "$ANSWER" ]
531 then {
532 if mkdir -p "$ANSWER"
533 then CROOT="$ANSWER"
534 else
535 echo "Directory $ANSWER can't be created !"
536 conf_reset_question drivec_path
539 else CROOT="$ANSWER"
542 done
543 echo "Configuring Wine for a no-windows install in $CROOT..."
545 create_windows_directories
546 configure_wine_applications
548 # create $LCONF using the default config file $WINEINI
549 if [ "$DOLOCALCONF" = 'yes' ]
550 then {
551 sed "s|\"Path\" = \"/c\"\$|\"Path\" = \"${CROOT}\"|" $WINEINI > $TMPCONF
552 conf_reset_question default_config
553 conf_question low default_config \
554 "Created $LCONF using default Wine configuration." \
555 "You probably want to review the file, though."
559 # now we really should install the registry
560 if [ "$DOREG" = 'auto' ]
561 then DOREG=yes
565 echo
567 #install the local config file $LCONF
568 if [ "$DOLOCALCONF" = 'yes' ]
569 then
570 if [ ! -w ~/.wine ]
571 then
572 mkdir ~/.wine
574 cp $TMPCONF $LCONF > /dev/null
575 else
576 DOREG=no
579 #install the global config file $GCONF
580 if [ "$DOGLOBALCONF" = 'yes' ]
581 then
582 if [ ! -f $sysconfdir ]
583 then
584 mkdir -p $sysconfdir
587 cp $TMPCONF $GCONF > /dev/null
590 # check whether we need to install default registry
591 # (not to be done if windows registry exists)
592 if [ "$DOREG" = 'auto' ]
593 then {
594 CROOT=`sed -n '/^\[Drive C\]$/,/^\[.*\]$/ s/^\"Path\" = \"\(.*\)\"/\1/p' $LCONF`
595 echo "Checking for real Windows registry..."
596 if [ -f "$CROOT/windows/system.dat" ]
597 then DOREG=no
598 elif [ -f "$CROOT/windows/system32/config/system" ]
599 then DOREG=no
600 elif [ -f "$CROOT/WINNT/system32/config/system" ]
601 then DOREG=no
602 else DOREG=yes
604 if [ "$DOREG" = 'yes' ]
605 then echo "Not found, default Wine registry will be installed."
606 else echo "Windows registry found, will not install default Wine registry."
608 echo
612 # install default registry entries
613 if [ "$DOREG" = 'yes' ]
614 then {
615 if [ "$BINDIST" = 'no' ]
616 then {
617 echo "Compiling regedit..."
618 (cd programs/regedit; make)
619 echo
622 echo "Preparing to install default Wine registry entries..."
624 # Make sure we are on a Windows drive
625 mv $LCONF $LCONF.orig
626 sed "s/\"Path\" = \"%HOME%\"$/\"Path\" = \"%PWD%\"/" $LCONF.orig> $LCONF
628 echo "Installing default Wine registry entries..."
629 echo
630 if ! $REGEDIT $DEFREG > /dev/null
631 then {
632 echo "Registry install failed."
633 mv $LCONF.orig $LCONF
634 conf_reset_question regedit_error
635 conf_question high regedit_error
636 exit 1
638 else {
639 echo
640 echo "Registry entries successfully installed."
641 mv $LCONF.orig $LCONF
644 if [ "$SYSREG" = 'auto' ]
645 then SYSREG=yes
650 # make root's registry global, if desired
651 if [ `whoami` = 'root' ] && [ "$DOREG" = 'yes' ] && [ "$SYSREG" = 'yes' ]
652 then {
653 [ -d ~/.wine ] || mkdir ~/.wine
654 if ! [ -f $sysconfdir/wine.userreg ]
655 then {
656 echo "Linking root's user registry hive to the global registry..."
657 [ -f ~/.wine/wine.userreg ] && cp ~/.wine/wine.userreg $sysconfdir/wine.userreg
658 ln -sf $sysconfdir/wine.userreg ~/.wine/wine.userreg
661 if ! [ -f $sysconfdir/wine.systemreg ]
662 then {
663 echo "Linking root's system registry hive to the global registry..."
664 [ -f ~/.wine/system.reg ] && cp ~/.wine/system.reg $sysconfdir/wine.systemreg
665 ln -sf $sysconfdir/wine.systemreg ~/.wine/system.reg
671 # cleanup any temporary files that may remain
672 if [ -f $TMPCONF ]
673 then rm -f $TMPCONF
677 # it's a wrap
678 echo
679 echo "Installation complete for now. Good luck (this is still alpha software)."
680 echo "If you have problems with WINE, please read the documentation first,"
681 echo "as many kinds of potential problems are explained there."
683 exit 0